stages:
  - "Extract source code"
  - "Performing benchmarks"
  - "Post-processing results"
  - "Publishing"

tangle:
  stage: "Extract source code"
  tags: ["guix"]
  script:
    - >
      guix shell --pure git emacs emacs-org -- emacs --batch --no-init-file
      -l org --eval '(progn (setq org-src-preserve-indentation t) (dolist (file
      (directory-files-recursively "." "\\.org$"))
      (org-babel-tangle-file file)))'
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
  artifacts:
    paths:
      - benchmarks/run.sh
      - benchmarks/definitions.csv
      - plot.R
      - experiments.scm
      - post-processing.scm
      - channels.scm
  
test-fembem:
  stage: "Performing benchmarks"
  tags: ["guix"]
  script:
    - >
      guix time-machine -C channels.scm -- shell --pure -m experiments.scm --
      ./benchmarks/run.sh -d ./benchmarks/definitions.csv
      -o ./benchmarks/results
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
  artifacts:
    paths:
      - benchmarks/results

figures:
  stage: "Post-processing results"
  tags: ["guix"]
  script:
    - >
      guix time-machine -C channels.scm -- shell --pure
      -m post-processing.scm -- Rscript ./plot.R
      ./benchmarks/results/results.csv
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
  artifacts:
    paths:
      - figures/*.svg

pages:
  stage: "Publishing"
  tags: ["guix"]
  script:
    - >
      guix time-machine -C channels.scm -- shell --pure
      -m post-processing.scm -- emacs --batch --no-init-file --load publish.el
      --eval '(org-publish "study")'
    - >
      guix time-machine -C channels.scm -- shell --pure
      -m post-processing.scm -- emacs --batch --no-init-file --load publish.el
      --eval '(org-publish "study-static")'
    - mv ./public/study-article.html ./public/index.html
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
  artifacts:
    paths:
      - public
